import { Component, OnInit } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';

@Component({
    selector: 'snsd148f',
    templateUrl: './SNSD148_F.component.html',
    styleUrls: ['./SNSD148_F.component.css']
})

export class SNSD148_FComponent implements OnInit {


    constructor(
        private http: HttpService,
        private router: Router
    ) { }

    public currentDate: string;
    public CustomerList: any = [];

    ngOnInit() {
        this.currentDate = this.GetFormateDate()
    }

    GetFormateDate() {

        let _date = new Date();
        let day = _date.getDate();
        let year = _date.getFullYear()
        let month = _date.getMonth() + 1;
        let newMonth = month.toString().length < 2 ? 0 + '' + month : month
        return day + '-' + newMonth + '-' + year

    }
}

