import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { FormGroup, FormControl, FormBuilder } from '@angular/forms'
import { Router } from '@angular/router';
import { Observable, config } from 'rxjs';
import { MatTableDataSource, MatTableModule } from '@angular/material/table';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';

@Component({
  selector: 'snse026n',
  templateUrl: './SNSE026N.component.html',
  styleUrls: ['./SNSE026N.component.css']
})



export class SNSE026NComponent implements OnInit {

  constructor(
    private http: HttpService,
    private router: Router
  ) { }

  public CustomerList: any;
  private loaded: boolean = false;

  public headerList: Array<any> = [];
  public headerListC: Array<any> = [];
  public dataList: any;
  public displayedColumns: string[] = [];
  public displayedColumnsC: string[] = [];
  public tableData: any;
  public isCustomContent: boolean = false;


  public tableDataC: any;
  public dataListC: any;

  public tableName: string;
  public Ischecked: boolean;


  ngOnInit() {

    this.tableName = "ReportConfigure";
    this.CustomerList = [{ ID: 1, CUSTOMER_CODE: "AAA" }, { ID: 2, CUSTOMER_CODE: "BBB" }, { ID: 3, CUSTOMER_CODE: "CCC" }]



    this.headerList = [
      { FIELD_NAME: "Allocate_Date", TITLE: "Allocate Date" },
      { FIELD_NAME: "Check", TITLE: "" }
    ]

    console.log('headerList', this.headerList)

    this.tableData = [
      {
        "Allocate_Date": "A",
       
      }, {
        "Allocate_Date": "B",      
      },
      {
        "Allocate_Date": "C",
      },
      {
        "Allocate_Date": "A",      
      },
      {
        "Allocate_Date": "A",    
      },
      {
        "Allocate_Date": "A",  
      },
      {
        "Allocate_Date": "A",
      },
      {
        "Allocate_Date": "A",      
      },
      {
        "Allocate_Date": "A",    
      },
      {
        "Allocate_Date": "A",      
      },
      {
        "Allocate_Date": "A",        
      },
      {
        "Allocate_Date": "A",      
      }
    ]

    
    this.headerListC = [
      { FIELD_NAME: "Customer_Code", TITLE: "Customer Code" },
      { FIELD_NAME: "Customer_Name", TITLE: "Customer Name" },
      { FIELD_NAME: "Check", TITLE: "" }
    ]

    this.tableDataC = [
      { "Customer_Code": "A", Customer_Name: "A" }, { "Customer_Code": "B", Customer_Name: "B" }, { "Customer_Code": "V", Customer_Name: "V" }, { "Customer_Code": "C", Customer_Name: "C" }, { "Customer_Code": "A", Customer_Name: "A" }, { "Customer_Code": "A", Customer_Name: "A" }, { "Customer_Code": "A", Customer_Name: "A" }, { "Customer_Code": "A", Customer_Name: "A" }, { "Customer_Code": "A", Customer_Name: "A" }, { "Customer_Code": "A", Customer_Name: "A" },
      { "Customer_Code": "A", Customer_Name: "A" }, { "Customer_Code": "A", Customer_Name: "A" }
    ]

    this.dataList = new MatTableDataSource<any>(this.tableData);
    this.dataListC = new MatTableDataSource<any>(this.tableDataC);

    this.displayedColumns = this.headerList.map(v => v.FIELD_NAME);
    this.displayedColumnsC = this.headerListC.map(x => x.FIELD_NAME);
    
    this.loaded = true;
  }

}
