import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { FormGroup, FormControl, FormBuilder } from '@angular/forms'
import { Router } from '@angular/router';
import { Observable, config } from 'rxjs';
import { MatTableDataSource, MatTableModule } from '@angular/material/table';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';

@Component({
  selector: 'snse037',
  templateUrl: './SNSE037.component.html',
  styleUrls: ['./SNSE037.component.css']
})



export class SNSE037Component implements OnInit {


  @ContentChild(TemplateRef, { static: false }) templateRef;
  @ViewChild(MatPaginator, { static: true }) paginator: MatPaginator;
  @ViewChild(MatSort, { static: true }) sort: MatSort;

  constructor(
    private http: HttpService,
    private router: Router
  ) { }

  //@ViewChild('fileUpload') myInputVariable: ElementRef;

  @Input() config: any;
  @Input() data: any;
  @Output() datacallback = new EventEmitter<string>();


  public CustomerList: any;
  private loaded: boolean = false;

  public headerList: Array<any> = [];
  public headerList2: Array<any> = [];
  public dataList: any;
  public displayedColumns: string[] = [];
  public displayedColumns2: string[] = [];
  public tableData: any;
  public isCustomContent: boolean = false;


  public tableData2: any;
  public dataList2: any;

  public tableName: string;


  ngOnInit() {

    this.tableName = "ReportConfigure";
    this.CustomerList = [{ ID: 1, CUSTOMER_CODE: "AAA" }, { ID: 2, CUSTOMER_CODE: "BBB" }, { ID: 3, CUSTOMER_CODE: "CCC" }]



    this.headerList = [

      { FIELD_NAME: "Send_By", TITLE: "Sent By" },
      { FIELD_NAME: "Case_No", TITLE: "Case No" },
      { FIELD_NAME: "Gross_Weigth", TITLE: "Gross Weigth" },

      { FIELD_NAME: "Gross_mm", TITLE: "Gross mm" },
      { FIELD_NAME: "Status", TITLE: "Status" },
      { FIELD_NAME: "Check", TITLE: "" }
    ]

    this.tableData = [
      {
        "Send_By": "A",
        "Case_No": "A",
        "Gross_Weigth": "A",
        "Gross_mm": "A",
        "Status": "A"

      }, {
        "Send_By": "A",
        "Case_No": "A",
        "Gross_Weigth": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Send_By": "A",
        "Case_No": "A",
        "Gross_Weigth": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Send_By": "A",
        "Case_No": "A",
        "Gross_Weigth": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Send_By": "A",
        "Case_No": "A",
        "Gross_Weigth": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Send_By": "A",
        "Case_No": "A",
        "Gross_Weigth": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Send_By": "A",
        "Case_No": "A",
        "Gross_Weigth": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Send_By": "A",
        "Case_No": "A",
        "Gross_Weigth": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Send_By": "A",
        "Case_No": "A",
        "Gross_Weigth": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Send_By": "A",
        "Case_No": "A",
        "Gross_Weigth": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Send_By": "A",
        "Case_No": "A",
        "Gross_Weigth": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Send_By": "A",
        "Case_No": "A",
        "Gross_Weigth": "A",
        "Gross_mm": "A",
        "Status": "A"
      }
    ]

    this.headerList2 = [

      { FIELD_NAME: "Customer_Code", TITLE: "Customer Code" },
      { FIELD_NAME: "Customer_Name", TITLE: "Customer Name" },
      { FIELD_NAME: "Amount", TITLE: "Amount" }   
    ]

    this.tableData2 = [
      {
        "Customer_Code": "A",
        "Customer_Name": "A",
        "Amount": "A",
        "Gross_mm": "A",
        "Status": "A"

      }, {
        "Customer_Code": "A",
        "Customer_Name": "A",
        "Amount": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Customer_Code": "A",
        "Customer_Name": "A",
        "Amount": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Customer_Code": "A",
        "Customer_Name": "A",
        "Amount": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Customer_Code": "A",
        "Customer_Name": "A",
        "Amount": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Customer_Code": "A",
        "Customer_Name": "A",
        "Amount": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Customer_Code": "A",
        "Customer_Name": "A",
        "Amount": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Customer_Code": "A",
        "Customer_Name": "A",
        "Amount": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Customer_Code": "A",
        "Customer_Name": "A",
        "Amount": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Customer_Code": "A",
        "Customer_Name": "A",
        "Amount": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Customer_Code": "A",
        "Customer_Name": "A",
        "Amount": "A",
        "Gross_mm": "A",
        "Status": "A"
      },
      {
        "Customer_Code": "A",
        "Customer_Name": "A",
        "Amount": "A",
        "Gross_mm": "A",
        "Status": "A"
      }
    ]

    this.dataList = new MatTableDataSource<any>(this.tableData);
    this.dataList2 = new MatTableDataSource<any>(this.tableData2);

    this.displayedColumns = this.headerList.map(v => v.FIELD_NAME);
    this.displayedColumns2 = this.headerList2.map(v => v.FIELD_NAME);

    this.loaded = true;
  }

  ngAfterContentInit(): void {
    if (this.templateRef) {
      this.isCustomContent = true;
    }
  }


  ngOnChanges(): void {

    this.dataList.paginator = this.paginator;
    this.dataList.sort = this.sort;
  }

  receiveMessage($event) {

  }








}
