import { Component, OnInit } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { SelectionModel } from '@angular/cdk/collections';

@Component({
    selector: 'SNSQ005_W',
    templateUrl: './SNSQ005_W.component.html',
    styleUrls: ['./SNSQ005_W.component.css']
})

export class SNSQ005_WComponent implements OnInit{

    constructor(
        private http: HttpService,
        private router: Router
  ) { }

  public tableData: any = [];
  public ParamSearch: any = {};

  
    
    ngOnInit() {

  }

  public ConfigPoNo: any = {
    ColName: "PO_NO",
    ColValue: "",
    PlaceholderText: "Select Po No",
    SourceController: "SL",
    SourceMethodName: "SNSQ005_W_GET_PO",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigVendorCode: any = {
    ColName: "LOOKUP_VENDOR",
    ColValue: "",
    PlaceholderText: "Select Vendor Code",
    SourceController: "SL",
    SourceMethodName: "SNSQ005_W_GET_VENDOR_CODE",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public Search() {
    this.tableData = [];
    this.http.post("SL", "SNSQ005W_GET_DATA", this.ParamSearch)
      .subscribe(res => {
        this.tableData = res.Table;
      })
  }

    




}
