import { Component, OnInit } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { Router } from "@angular/router";
import { MatTableDataSource } from "@angular/material/table";


@Component({
  selector: 'snsq041_001',
  templateUrl: './SNSQ041_001.component.html',
  styleUrls: ['./SNSQ041_001.component.css']

})


export class SNSQ041_001Component implements OnInit {

  constructor(
    private HttpService: HttpService,
    private router : Router
  ) { }


  public CustomerList: any;
  public tableData: any;
  public headerList: Array<any> = [];
  public dataList: any;
  public displayedColumns: string[] = [];

  ngOnInit() {

    this.getTableHeader()

    this.CustomerList = [{ ID: 1, PO_Date: "AAA" }, { ID: 2, PO_Date: "BBB" }, { ID: 3, PO_Date: "CCC" }]

    this.tableData = [
      {
        "PO_No": "A",
        "PO_Date": "A",
        "Order_No": "A",
        "Order_Date": "A",
        "Item_No": "A",
        "Order_Part_No": "A",
        "Accept_Part_No": "A",
        "Part_Number": "A",
        "Accept_Qty": "A",
        "Allocate_Date": "A",
        "Order_Class": "A",
        "Instruction_No": "A",
        "Sub_Item_No": "A",
        "Customer_Name": "A"
      },
      {
        "PO_No": "A",
        "PO_Date": "A",
        "Order_No": "A",
        "Order_Date": "A",
        "Item_No": "A",
        "Order_Part_No": "A",
        "Accept_Part_No": "A",
        "Part_Number": "A",
        "Accept_Qty": "A",
        "Allocate_Date": "A",
        "Order_Class": "A",
        "Instruction_No": "A",
        "Sub_Item_No": "A",
        "Customer_Name": "A"
      },
      {
        "PO_No": "A",
        "PO_Date": "A",
        "Order_No": "A",
        "Order_Date": "A",
        "Item_No": "A",
        "Order_Part_No": "A",
        "Accept_Part_No": "A",
        "Part_Number": "A",
        "Accept_Qty": "A",
        "Allocate_Date": "A",
        "Order_Class": "A",
        "Instruction_No": "A",
        "Sub_Item_No": "A",
        "Customer_Name": "A"
      }, {
        "PO_No": "A",
        "PO_Date": "A",
        "Order_No": "A",
        "Order_Date": "A",
        "Item_No": "A",
        "Order_Part_No": "A",
        "Accept_Part_No": "A",
        "Part_Number": "A",
        "Accept_Qty": "A",
        "Allocate_Date": "A",
        "Order_Class": "A",
        "Instruction_No": "A",
        "Sub_Item_No": "A",
        "Customer_Name": "A"
      }, {
        "PO_No": "A",
        "PO_Date": "A",
        "Order_No": "A",
        "Order_Date": "A",
        "Item_No": "A",
        "Order_Part_No": "A",
        "Accept_Part_No": "A",
        "Part_Number": "A",
        "Accept_Qty": "A",
        "Allocate_Date": "A",
        "Order_Class": "A",
        "Instruction_No": "A",
        "Sub_Item_No": "A",
        "Customer_Name": "A"
      }, {
        "PO_No": "A",
        "PO_Date": "A",
        "Order_No": "A",
        "Order_Date": "A",
        "Item_No": "A",
        "Order_Part_No": "A",
        "Accept_Part_No": "A",
        "Part_Number": "A",
        "Accept_Qty": "A",
        "Allocate_Date": "A",
        "Order_Class": "A",
        "Instruction_No": "A",
        "Sub_Item_No": "A",
        "Customer_Name": "A"
      }, {
        "PO_No": "A",
        "PO_Date": "A",
        "Order_No": "A",
        "Order_Date": "A",
        "Item_No": "A",
        "Order_Part_No": "A",
        "Accept_Part_No": "A",
        "Part_Number": "A",
        "Accept_Qty": "A",
        "Allocate_Date": "A",
        "Order_Class": "A",
        "Instruction_No": "A",
        "Sub_Item_No": "A",
        "Customer_Name": "A"
      }, {
        "PO_No": "A",
        "PO_Date": "A",
        "Order_No": "A",
        "Order_Date": "A",
        "Item_No": "A",
        "Order_Part_No": "A",
        "Accept_Part_No": "A",
        "Part_Number": "A",
        "Accept_Qty": "A",
        "Allocate_Date": "A",
        "Order_Class": "A",
        "Instruction_No": "A",
        "Sub_Item_No": "A",
        "Customer_Name": "A"
      }, {
        "PO_No": "A",
        "PO_Date": "A",
        "Order_No": "A",
        "Order_Date": "A",
        "Item_No": "A",
        "Order_Part_No": "A",
        "Accept_Part_No": "A",
        "Part_Number": "A",
        "Accept_Qty": "A",
        "Allocate_Date": "A",
        "Order_Class": "A",
        "Instruction_No": "A",
        "Sub_Item_No": "A",
        "Customer_Name": "A"
      },
      {
        "PO_No": "A",
        "PO_Date": "A",
        "Order_No": "A",
        "Order_Date": "A",
        "Item_No": "A",
        "Order_Part_No": "A",
        "Accept_Part_No": "A",
        "Part_Number": "A",
        "Accept_Qty": "A",
        "Allocate_Date": "A",
        "Order_Class": "A",
        "Instruction_No": "A",
        "Sub_Item_No": "A",
        "Customer_Name": "A"
      }
    ]
  }

  getTableHeader() {
    this.HttpService.get("System", "GetHeaderGridView", 'SNSQ041_001_T1')
      .subscribe(result => {
        this.headerList = result.filter(v => v.VISIBILITY === true);
        this.displayedColumns = this.headerList.map(v => v.FIELD_NAME);
        console.log('displayedColumns', this.displayedColumns)
        this.dataList = new MatTableDataSource<any>(this.tableData);
      })
  }
}
