import { Component, OnInit, ViewContainerRef } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';



@Component({
    selector: 'snsq090',
    templateUrl: './SNSQ090.component.html',
    styleUrls: ['./SNSQ090.component.css']
})

export class SNSQ090Component implements OnInit {

    constructor(
        private http: HttpService,
        private modal : ModalService,
        private viewref : ViewContainerRef,
        private global : Globals
    ) { }

    public tblFooterTab1: any = [
        {
          fieldName: "SMALL_ITEM",value: "",show: true
        },
        {
          fieldName: "MEDIUM_ITEM",value: "",show: true
        },
        {
          fieldName: "LARGE_ITEM",value: "",show: true
        },
        {
            fieldName : "HEAVY_ITEM",value : "",show : true
        },
        {
            fieldName : "HIGHT_ITEM",value : "",show : true
        },
        {
            fieldName : "OTHER_ITEM",value : "",show : true
        },
        {
            fieldName : "SUM_ITEM",value : "",show : true
        },
        {
            fieldName: "SMALL_QTY",value: "",show: true
          },
          {
            fieldName: "MEDIUM_QTY",value: "",show: true
          },
          {
            fieldName: "LARGE_QTY",value: "",show: true
          },
          {
              fieldName : "HEAVY_QTY",value : "",show : true
          },
          {
              fieldName : "HIGHT_QTY",value : "",show : true
          },
          {
              fieldName : "OTHER_QTY",value : "",show : true
          },
          {
              fieldName : "SUM_QTY",value : "",show : true
          }
      ]


      public tblFooterTab2: any = [
        {
          fieldName: "CLAIM_ITEM",value: "",show: true
        },
        {
          fieldName: "EMERGENCY_ITEM",value: "",show: true
        },
        {
          fieldName: "INDENT_ITEM",value: "",show: true
        },
        {
            fieldName : "REGULAR_ITEM",value : "",show : true
        },
        {
            fieldName : "WHOLESALES_ITEM",value : "",show : true
        },
        {
            fieldName : "OIL_ITEM",value : "",show : true
        },
        {
            fieldName : "SUM_ITEM",value : "",show : true
        },
        {
            fieldName: "CLAIM_QTY",value: "",show: true
          },
          {
            fieldName: "EMERGENCY_QTY",value: "",show: true
          },
          {
            fieldName: "INDENT_QTY",value: "",show: true
          },
          {
              fieldName : "REGULAR_QTY",value : "",show : true
          },
          {
              fieldName : "WHOLESALES_QTY",value : "",show : true
          },
          {
              fieldName : "OIL_QTY",value : "",show : true
          },
          {
              fieldName : "SUM_QTY",value : "",show : true
          }
      ]


      public tblFooterTab3: any = [
        {
          fieldName: "BKKCAR_ITEM",value: "",show: true
        },
        {
          fieldName: "BKKPART_ITEM",value: "",show: true
        },
        {
          fieldName: "UPCCAR_ITEM",value: "",show: true
        },
        {
            fieldName : "UPCPART_ITEM",value : "",show : true
        },
        {
            fieldName : "OTHER_ITEM",value : "",show : true
        },
        {
            fieldName : "AIR_ITEM",value : "",show : true
        },
        {
            fieldName : "SEA_ITEM",value : "",show : true
        },
        {
            fieldName: "SUM_ITEM",value: "",show: true
          },
          {
            fieldName: "BKKCAR_QTY",value: "",show: true
          },
          {
            fieldName: "BKKPART_QTY",value: "",show: true
          },
          {
              fieldName : "UPCCAR_QTY",value : "",show : true
          },
          {
              fieldName : "UPCPART_QTY",value : "",show : true
          },
          {
              fieldName : "OTHER_QTY",value : "",show : true
          },
          {
              fieldName : "AIR_QTY",value : "",show : true
          },
          {
            fieldName : "SEA_QTY",value : "",show : true
          },
          {
            fieldName : "SUM_QTY",value : "",show : true
          }
      ]


      public tblFooterTab4: any = [
        {
          fieldName: "DWP_08_ITEM",value: "",show: true
        },
        {
          fieldName: "DWP_09_ITEM",value: "",show: true
        },
        {
          fieldName: "DWP_10_ITEM",value: "",show: true
        },
        {
            fieldName : "DWP_11_ITEM",value : "",show : true
        },
        {
            fieldName : "DWP_12_ITEM",value : "",show : true
        },
        {
            fieldName : "DWP_13_ITEM",value : "",show : true
        },
        {
            fieldName : "DWP_14_ITEM",value : "",show : true
        },
        {
            fieldName: "DWP_15_ITEM",value: "",show: true
          },
          {
            fieldName: "DWP_16_ITEM",value: "",show: true
          },
          {
            fieldName: "DWP_OT_ITEM",value: "",show: true
          },
          {
              fieldName : "DSUM_ITEM",value : "",show : true
          },
         
          {
            fieldName: "EWP_08_ITEM",value: "",show: true
          },
          {
            fieldName: "EWP_09_ITEM",value: "",show: true
          },
          {
            fieldName: "EWP_10_ITEM",value: "",show: true
          },
          {
              fieldName : "EWP_11_ITEM",value : "",show : true
          },
          {
              fieldName : "EWP_12_ITEM",value : "",show : true
          },
          {
              fieldName : "EWP_13_ITEM",value : "",show : true
          },
          {
              fieldName : "EWP_14_ITEM",value : "",show : true
          },
          {
              fieldName: "EWP_15_ITEM",value: "",show: true
            },
            {
              fieldName: "EWP_16_ITEM",value: "",show: true
            },
            {
              fieldName: "EWP_OT_ITEM",value: "",show: true
            },
            {
                fieldName : "ESUM_ITEM",value : "",show : true
            },
            {
                fieldName : "ALL_SUM_ITEM",value : "",show : true
            },

            


            {
                fieldName: "DWP_08_QTY",value: "",show: true
              },
              {
                fieldName: "DWP_09_QTY",value: "",show: true
              },
              {
                fieldName: "DWP_10_QTY",value: "",show: true
              },
              {
                  fieldName : "DWP_11_QTY",value : "",show : true
              },
              {
                  fieldName : "DWP_12_QTY",value : "",show : true
              },
              {
                  fieldName : "DWP_13_QTY",value : "",show : true
              },
              {
                  fieldName : "DWP_14_QTY",value : "",show : true
              },
              {
                  fieldName: "DWP_15_QTY",value: "",show: true
                },
                {
                  fieldName: "DWP_16_QTY",value: "",show: true
                },
                {
                  fieldName: "DWP_OT_QTY",value: "",show: true
                },
                {
                    fieldName : "DSUM_QTY",value : "",show : true
                },
               
                {
                  fieldName: "EWP_08_QTY",value: "",show: true
                },
                {
                  fieldName: "EWP_09_QTY",value: "",show: true
                },
                {
                  fieldName: "EWP_10_QTY",value: "",show: true
                },
                {
                    fieldName : "EWP_11_QTY",value : "",show : true
                },
                {
                    fieldName : "EWP_12_QTY",value : "",show : true
                },
                {
                    fieldName : "EWP_13_QTY",value : "",show : true
                },
                {
                    fieldName : "EWP_14_QTY",value : "",show : true
                },
                {
                    fieldName: "EWP_15_QTY",value: "",show: true
                  },
                  {
                    fieldName: "EWP_16_QTY",value: "",show: true
                  },
                  {
                    fieldName: "EWP_OT_QTY",value: "",show: true
                  },
                  {
                      fieldName : "ESUM_QTY",value : "",show : true
                  },
                  {
                    fieldName : "ALL_SUM_QTY",value : "",show : true
                },
      ]

    public ConfigStaff: any = {
        ColName: "STAFF_NAME",
        ColValue: "",
        PlaceholderText: "Select Staff.",
        SourceController: "WH",
        SourceMethodName: "SNSQ090_GetStaffWH",
        NoOfShowRecords: 50,
        MinLengthSearch: 1
      }

    public CurrentTab : number = 0;
    public tableData: any = [];
    public tableData2: any = [];
    public tableData3: any = [];
    public tableData4: any = [];

    public Params = {
        FROM_DATE : new Date(),
        TO_DATE : new Date(),
        DATE_TYPE : 'S',
        SECTION_CODE : 'A',
        STAFF_ID : null,
        STAFF_NAME : null,
        FROM_DATE_FORMAT : null,
        TO_DATE_FORMAT : null,
        CURRENT_TAB : 0
    }

    ngOnInit() {
       
        this.Params.FROM_DATE = this.FirstDateOfMonth();
    }


    Search(){

        this.Params.FROM_DATE_FORMAT = this.FormateDate(this.Params.FROM_DATE);
        //this.Params.FROM_DATE_FORMAT = "01-01-2016";
        this.Params.TO_DATE_FORMAT = this.FormateDate(this.Params.TO_DATE);
        this.Params.CURRENT_TAB = this.CurrentTab;

        switch(this.CurrentTab) 
        {
            case 0 :
                this.tableData = [];
                this.http.post("WH","SNSQ090_GetData",this.Params)
                .subscribe(res => {
                    if(res.Table.length > 0){
                        res.Table.map((x,i) => {
                            x.SEQ = i + 1
                        })
                        
                    }
                    this.GenFooterValue(res.Table);
                    this.tableData = res.Table;
                    console.log('tableData',this.tableData)
                
                    
                })
                break;
            case 1 :
                this.tableData2 = [];
                this.http.post("WH","SNSQ090_GetData",this.Params)
                .subscribe(res => {
                    if(res.Table.length > 0){
                        res.Table.map((x,i) => {
                            x.SEQ = i + 1
                        })
                    }
                    this.GenFooterValue(res.Table);
                    this.tableData2 = res.Table;
                })
                break;
            case 2 :
                this.tableData3 = [];
                this.http.post("WH","SNSQ090_GetData",this.Params)
                .subscribe(res => {
                    if(res.Table.length > 0){
                        res.Table.map((x,i) => {
                            x.SEQ = i + 1
                        })
                    }
                    this.GenFooterValue(res.Table);
                    this.tableData3 = res.Table;
                })
                break;
            case 3 :
                this.tableData4 = [];
                this.http.post("WH","SNSQ090_GetData",this.Params)
                .subscribe(res => {
                    if(res.Table.length > 0){
                        res.Table.map((x,i) => {
                            x.SEQ = i + 1
                        })
                    }                   
                    this.GenFooterValue(res.Table);
                    this.tableData4 = res.Table;
                })
                break;     
            default:
                console.log("Tab Not Found");
                break
        }
    }

    Download(){
        let serviceName  = "";
        let data : any = []
        let fileName = ""
        switch (this.CurrentTab)
        {
            case 0 :
                serviceName = "SNSQ090Tab1_Download"
                data = this.tableData
                fileName = "SNSQ090_LocationType"
                break;
            case 1 :
                serviceName = "SNSQ090Tab2_Download"
                data = this.tableData2
                fileName = "SNSQ090_OrderClass"
                break;
            case 2 :
                serviceName = "SNSQ090Tab3_Download"
                data = this.tableData3
                fileName = "SNSQ090_SalesChannel"
                break;
            case 3 :
                serviceName = "SNSQ090Tab4_Download"
                data = this.tableData4
                fileName = "SNSQ090_Timing"
                break;
            default :
                break;
        }


        this.http.Download("WH",serviceName,data)
            .subscribe(res => {
                console.log(res)
                this.WriteContents(res,fileName)
            })
       
    }

    WriteContents(content,filename) {
        const a = document.createElement('a');
        const file = new Blob([content], { type: content.type });
        a.href = URL.createObjectURL(file);
        a.download = filename + '_' + this.global.CurrentDate() + ".csv";
        a.click();
      }
    

    GenFooterValue(data){
        switch(this.CurrentTab){
            case 0 :
               
                let sumSmallItem = this.SumFooter(data,this.tblFooterTab1[0].fieldName);
                let sumMediumItem = this.SumFooter(data,this.tblFooterTab1[1].fieldName);
                let sumLargeItem = this.SumFooter(data,this.tblFooterTab1[2].fieldName);
                let sumHeavyItem = this.SumFooter(data,this.tblFooterTab1[3].fieldName);
                let sumHightItem = this.SumFooter(data,this.tblFooterTab1[4].fieldName);
                let sumOtherItem = this.SumFooter(data,this.tblFooterTab1[5].fieldName);
                let sumTotalItem = this.SumFooter(data,this.tblFooterTab1[6].fieldName);

               
                let sumSmallQty = this.SumFooter(data,this.tblFooterTab1[7].fieldName);
                let sumMediumQty = this.SumFooter(data,this.tblFooterTab1[8].fieldName);
                let sumLargeQty = this.SumFooter(data,this.tblFooterTab1[9].fieldName);
                let sumHeavyQty = this.SumFooter(data,this.tblFooterTab1[10].fieldName);
                let sumHightQty = this.SumFooter(data,this.tblFooterTab1[11].fieldName);
                let sumOtherQty = this.SumFooter(data,this.tblFooterTab1[12].fieldName);
                let sumTotalQty = this.SumFooter(data,this.tblFooterTab1[13].fieldName);


                this.tblFooterTab1[0].value = sumSmallItem.toLocaleString() + '\n' + this.global.Round(((sumSmallItem * 100) / sumTotalItem),2) + '%';
                this.tblFooterTab1[1].value = sumMediumItem.toLocaleString() + '\n' + this.global.Round(((sumMediumItem * 100) / sumTotalItem),2) + '%';
                this.tblFooterTab1[2].value = sumLargeItem.toLocaleString() + '\n' + this.global.Round(((sumLargeItem * 100) / sumTotalItem),2) + '%';
                this.tblFooterTab1[3].value = sumHeavyItem.toLocaleString().toLocaleString() + '\n' + this.global.Round(((sumHeavyItem * 100) / sumTotalItem),2) + '%';
                this.tblFooterTab1[4].value = sumHightItem.toLocaleString() + '\n' + this.global.Round(((sumHightItem * 100) / sumTotalItem),2) + '%';
                this.tblFooterTab1[5].value = sumOtherItem.toLocaleString() + '\n' + this.global.Round(((sumOtherItem * 100) / sumTotalItem),2) + '%';
                //this.tblFooterTab1[6].value = sumTotalItem;

                this.tblFooterTab1[7].value =  sumSmallQty.toLocaleString() + '\n' + this.global.Round(((sumSmallQty * 100) / sumTotalQty),2) + '%';
                this.tblFooterTab1[8].value =  sumMediumQty.toLocaleString() + '\n' + this.global.Round(((sumMediumQty * 100) / sumTotalQty),2) + '%';
                this.tblFooterTab1[9].value =  sumLargeQty.toLocaleString() + '\n' + this.global.Round(((sumLargeQty * 100) / sumTotalQty),2) + '%';
                this.tblFooterTab1[10].value =  sumHeavyQty.toLocaleString() + '\n' + this.global.Round(((sumHeavyQty * 100) / sumTotalQty),2) + '%';
                this.tblFooterTab1[11].value =  sumHightQty.toLocaleString() + '\n' + this.global.Round(((sumHightQty * 100) / sumTotalQty),2) + '%';
                this.tblFooterTab1[12].value =  sumOtherQty.toLocaleString() + '\n' + this.global.Round(((sumOtherQty * 100) / sumTotalQty),2) + '%';
                //this.tblFooterTab1[13].value = sumTotalQty;

                break;
            case 1 :

                let sumClaimItem = this.SumFooter(data,this.tblFooterTab2[0].fieldName);
                let suumEmergencyItem = this.SumFooter(data,this.tblFooterTab2[1].fieldName);
                let sumIndentItem = this.SumFooter(data,this.tblFooterTab2[2].fieldName);
                let sumRegulartem = this.SumFooter(data,this.tblFooterTab2[3].fieldName);
                let sumWholesalesItem = this.SumFooter(data,this.tblFooterTab2[4].fieldName);
                let sumoilItem = this.SumFooter(data,this.tblFooterTab2[5].fieldName);
                let sumTotalItem2 = this.SumFooter(data,this.tblFooterTab2[6].fieldName);

               
                let sumClaimQty = this.SumFooter(data,this.tblFooterTab2[7].fieldName);
                let sumEmergencyQty = this.SumFooter(data,this.tblFooterTab2[8].fieldName);
                let sumIndentQty = this.SumFooter(data,this.tblFooterTab2[9].fieldName);
                let sumRegularQty = this.SumFooter(data,this.tblFooterTab2[10].fieldName);
                let sumWholesalesQty = this.SumFooter(data,this.tblFooterTab2[11].fieldName);
                let sumOilQty = this.SumFooter(data,this.tblFooterTab2[12].fieldName);
                let sumTotalQty2 = this.SumFooter(data,this.tblFooterTab2[13].fieldName);


                this.tblFooterTab2[0].value = sumClaimItem.toLocaleString() + '\n' + this.global.Round(((sumClaimItem * 100) / sumTotalItem2),2) + '%';
                this.tblFooterTab2[1].value = suumEmergencyItem.toLocaleString() + '\n' + this.global.Round(((suumEmergencyItem * 100) / sumTotalItem2),2) + '%';
                this.tblFooterTab2[2].value = sumIndentItem.toLocaleString() + '\n' + this.global.Round(((sumIndentItem * 100) / sumTotalItem2),2) + '%';
                this.tblFooterTab2[3].value = sumRegulartem.toLocaleString() + '\n' + this.global.Round(((sumRegulartem * 100) / sumTotalItem2),2) + '%';
                this.tblFooterTab2[4].value = sumWholesalesItem.toLocaleString() + '\n' + this.global.Round(((sumWholesalesItem * 100) / sumTotalItem2),2) + '%';
                this.tblFooterTab2[5].value = sumoilItem.toLocaleString() + '\n' + this.global.Round(((sumoilItem * 100) / sumTotalItem2),2) + '%';
                //this.tblFooterTab2[6].value = sumTotalItem2;

                this.tblFooterTab2[7].value = sumClaimQty.toLocaleString() + '\n' + this.global.Round(((sumClaimQty * 100) / sumTotalQty2),2) + '%';
                this.tblFooterTab2[8].value = sumEmergencyQty.toLocaleString() + '\n' + this.global.Round(((sumEmergencyQty * 100) / sumTotalQty2),2) + '%';
                this.tblFooterTab2[9].value = sumIndentQty.toLocaleString() + '\n' + this.global.Round(((sumIndentQty * 100) / sumTotalQty2),2) + '%';
                this.tblFooterTab2[10].value = sumRegularQty.toLocaleString() + '\n' + this.global.Round(((sumRegularQty * 100) / sumTotalQty2),2) + '%';
                this.tblFooterTab2[11].value = sumWholesalesQty.toLocaleString() + '\n' + this.global.Round(((sumWholesalesQty * 100) / sumTotalQty2),2) + '%';
                this.tblFooterTab2[12].value = sumOilQty.toLocaleString() + '\n' + this.global.Round(((sumOilQty * 100) / sumTotalQty2),2) + '%';
                //this.tblFooterTab2[13].value = sumTotalQty2;

                break;
            case 2 :
                let sumBkkCarItem = this.SumFooter(data,this.tblFooterTab3[0].fieldName);
                let sumBkkPartItem = this.SumFooter(data,this.tblFooterTab3[1].fieldName);
                let sumUpcCarItem = this.SumFooter(data,this.tblFooterTab3[2].fieldName);
                let sumUpcPartItem = this.SumFooter(data,this.tblFooterTab3[3].fieldName);
                let sumOtherItem3 = this.SumFooter(data,this.tblFooterTab3[4].fieldName);
                let sumAirItem = this.SumFooter(data,this.tblFooterTab3[5].fieldName);
                let sumSeaItem = this.SumFooter(data,this.tblFooterTab3[6].fieldName);
                let sumTotalItem3 = this.SumFooter(data,this.tblFooterTab3[7].fieldName);

                let sumBkkCarQty = this.SumFooter(data,this.tblFooterTab3[8].fieldName);
                let sumBkkPartQty = this.SumFooter(data,this.tblFooterTab3[9].fieldName);
                let sumUpcCarQty = this.SumFooter(data,this.tblFooterTab3[10].fieldName);
                let sumUpcPartQty = this.SumFooter(data,this.tblFooterTab3[11].fieldName);
                let sumOtherQty3 = this.SumFooter(data,this.tblFooterTab3[12].fieldName);
                let sumAirQty = this.SumFooter(data,this.tblFooterTab3[13].fieldName);
                let sumSeaQty = this.SumFooter(data,this.tblFooterTab3[14].fieldName);
                let sumTotalQty3 = this.SumFooter(data,this.tblFooterTab3[15].fieldName);


                this.tblFooterTab3[0].value = sumBkkCarItem.toLocaleString() + '\n' + this.global.Round(((sumBkkCarItem * 100) / sumTotalItem3),2) + '%';
                this.tblFooterTab3[1].value = sumBkkPartItem.toLocaleString() + '\n' + this.global.Round(((sumBkkPartItem * 100) / sumTotalItem3),2) + '%';
                this.tblFooterTab3[2].value = sumUpcCarItem.toLocaleString() + '\n' + this.global.Round(((sumUpcCarItem * 100) / sumTotalItem3),2) + '%';
                this.tblFooterTab3[3].value = sumUpcPartItem.toLocaleString() + '\n' + this.global.Round(((sumUpcPartItem * 100) / sumTotalItem3),2) + '%';
                this.tblFooterTab3[4].value = sumOtherItem3.toLocaleString() + '\n' + this.global.Round(((sumOtherItem3 * 100) / sumTotalItem3),2) + '%';
                this.tblFooterTab3[5].value = sumAirItem.toLocaleString() + '\n' + this.global.Round(((sumAirItem * 100) / sumTotalItem3),2) + '%';
                this.tblFooterTab3[6].value = sumSeaItem.toLocaleString() + '\n' + this.global.Round(((sumSeaItem * 100) / sumTotalItem3),2) + '%';

                this.tblFooterTab3[8].value = sumBkkCarQty.toLocaleString() + '\n' + this.global.Round(((sumBkkCarQty * 100) / sumTotalQty3),2) + '%';
                this.tblFooterTab3[9].value = sumBkkPartQty.toLocaleString() + '\n' + this.global.Round(((sumBkkPartQty * 100) / sumTotalQty3),2) + '%';
                this.tblFooterTab3[10].value = sumUpcCarQty.toLocaleString() + '\n' + this.global.Round(((sumUpcCarQty * 100) / sumTotalQty3),2) + '%';
                this.tblFooterTab3[11].value = sumUpcPartQty.toLocaleString() + '\n' + this.global.Round(((sumUpcPartQty * 100) / sumTotalQty3),2) + '%';
                this.tblFooterTab3[12].value = sumOtherQty3.toLocaleString() + '\n' + this.global.Round(((sumOtherQty3 * 100) / sumTotalQty3),2) + '%';
                this.tblFooterTab3[13].value = sumAirQty.toLocaleString() + '\n' + this.global.Round(((sumAirQty * 100) / sumTotalQty3),2) + '%';
                this.tblFooterTab3[14].value = sumSeaQty.toLocaleString() + '\n' + this.global.Round(((sumSeaQty * 100) / sumTotalQty3),2) + '%';

                break;
            case 3 :
                let dwp08item  = this.SumFooter(data,this.tblFooterTab4[0].fieldName);
                let dwp09item  = this.SumFooter(data,this.tblFooterTab4[1].fieldName);
                let dwp10item  = this.SumFooter(data,this.tblFooterTab4[2].fieldName);
                let dwp11item  = this.SumFooter(data,this.tblFooterTab4[3].fieldName);
                let dwp12item  = this.SumFooter(data,this.tblFooterTab4[4].fieldName);
                let dwp13item  = this.SumFooter(data,this.tblFooterTab4[5].fieldName);
                let dwp14item  = this.SumFooter(data,this.tblFooterTab4[6].fieldName);
                let dwp15item  = this.SumFooter(data,this.tblFooterTab4[7].fieldName);
                let dwp16item  = this.SumFooter(data,this.tblFooterTab4[8].fieldName);
                let dwpOTitem  = this.SumFooter(data,this.tblFooterTab4[9].fieldName);
                let dSumItem  = this.SumFooter(data,this.tblFooterTab4[10].fieldName);

                let ewp08item  = this.SumFooter(data,this.tblFooterTab4[11].fieldName);
                let ewp09item  = this.SumFooter(data,this.tblFooterTab4[12].fieldName);
                let ewp10item  = this.SumFooter(data,this.tblFooterTab4[13].fieldName);
                let ewp11item  = this.SumFooter(data,this.tblFooterTab4[14].fieldName);
                let ewp12item  = this.SumFooter(data,this.tblFooterTab4[15].fieldName);
                let ewp13item  = this.SumFooter(data,this.tblFooterTab4[16].fieldName);
                let ewp14item  = this.SumFooter(data,this.tblFooterTab4[17].fieldName);
                let ewp15item  = this.SumFooter(data,this.tblFooterTab4[18].fieldName);
                let ewp16item  = this.SumFooter(data,this.tblFooterTab4[19].fieldName);
                let ewpOTitem  = this.SumFooter(data,this.tblFooterTab4[20].fieldName);
                let ESumItem  = this.SumFooter(data,this.tblFooterTab4[21].fieldName);
                let AllSumItem  = this.SumFooter(data,this.tblFooterTab4[22].fieldName);


                let dwp08qty  = this.SumFooter(data,this.tblFooterTab4[23].fieldName);
                let dwp09qty  = this.SumFooter(data,this.tblFooterTab4[24].fieldName);
                let dwp10qty  = this.SumFooter(data,this.tblFooterTab4[25].fieldName);
                let dwp11qty  = this.SumFooter(data,this.tblFooterTab4[26].fieldName);
                let dwp12qty  = this.SumFooter(data,this.tblFooterTab4[27].fieldName);
                let dwp13qty  = this.SumFooter(data,this.tblFooterTab4[28].fieldName);
                let dwp14qty  = this.SumFooter(data,this.tblFooterTab4[29].fieldName);
                let dwp15qty  = this.SumFooter(data,this.tblFooterTab4[30].fieldName);
                let dwp16qty  = this.SumFooter(data,this.tblFooterTab4[31].fieldName);
                let dwpOTqty  = this.SumFooter(data,this.tblFooterTab4[32].fieldName);
                let dSumqty  = this.SumFooter(data,this.tblFooterTab4[33].fieldName);

                let ewp08qty  = this.SumFooter(data,this.tblFooterTab4[34].fieldName);
                let ewp09qty  = this.SumFooter(data,this.tblFooterTab4[35].fieldName);
                let ewp10qty  = this.SumFooter(data,this.tblFooterTab4[36].fieldName);
                let ewp11qty  = this.SumFooter(data,this.tblFooterTab4[37].fieldName);
                let ewp12qty  = this.SumFooter(data,this.tblFooterTab4[38].fieldName);
                let ewp13qty  = this.SumFooter(data,this.tblFooterTab4[39].fieldName);
                let ewp14qty  = this.SumFooter(data,this.tblFooterTab4[40].fieldName);
                let ewp15qty  = this.SumFooter(data,this.tblFooterTab4[41].fieldName);
                let ewp16qty  = this.SumFooter(data,this.tblFooterTab4[42].fieldName);
                let ewpOTqty  = this.SumFooter(data,this.tblFooterTab4[43].fieldName);
                let ESumqty  = this.SumFooter(data,this.tblFooterTab4[44].fieldName);
                let AllSumqty  = this.SumFooter(data,this.tblFooterTab4[45].fieldName);

                this.tblFooterTab4[0].value = dwp08item.toLocaleString() + '\n' + this.global.Round(((dwp08item * 100) / dSumItem),2) + '%';
                this.tblFooterTab4[1].value = dwp09item.toLocaleString() + '\n' + this.global.Round(((dwp09item * 100) / dSumItem),2) + '%';
                this.tblFooterTab4[2].value = dwp10item.toLocaleString() + '\n' + this.global.Round(((dwp10item * 100) / dSumItem),2) + '%';
                this.tblFooterTab4[3].value = dwp11item.toLocaleString() + '\n' + this.global.Round(((dwp11item * 100) / dSumItem),2) + '%';
                this.tblFooterTab4[4].value = dwp12item.toLocaleString() + '\n' + this.global.Round(((dwp12item * 100) / dSumItem),2) + '%';
                this.tblFooterTab4[5].value = dwp13item.toLocaleString() + '\n' + this.global.Round(((dwp13item * 100) / dSumItem),2) + '%';
                this.tblFooterTab4[6].value = dwp14item.toLocaleString() + '\n' + this.global.Round(((dwp14item * 100) / dSumItem),2) + '%';
                this.tblFooterTab4[7].value = dwp15item.toLocaleString() + '\n' + this.global.Round(((dwp15item * 100) / dSumItem),2) + '%';
                this.tblFooterTab4[8].value = dwp16item.toLocaleString() + '\n' + this.global.Round(((dwp16item * 100) / dSumItem),2) + '%';
                this.tblFooterTab4[9].value = dwpOTitem.toLocaleString() + '\n' + this.global.Round(((dwpOTitem * 100) / dSumItem),2) + '%';
                this.tblFooterTab4[10].value = dSumItem.toLocaleString() + '\n' + this.global.Round(((dSumItem * 100) / AllSumItem),2) + '%';

                this.tblFooterTab4[11].value = ewp08item.toLocaleString() + '\n' + this.global.Round(((ewp08item * 100) / ESumItem),2) + '%';
                this.tblFooterTab4[12].value = ewp09item.toLocaleString() + '\n' + this.global.Round(((ewp09item * 100) / ESumItem),2) + '%';
                this.tblFooterTab4[13].value = ewp10item.toLocaleString() + '\n' + this.global.Round(((ewp10item * 100) / ESumItem),2) + '%';
                this.tblFooterTab4[14].value = ewp11item.toLocaleString() + '\n' + this.global.Round(((ewp11item * 100) / ESumItem),2) + '%';
                this.tblFooterTab4[15].value = ewp12item.toLocaleString() + '\n' + this.global.Round(((ewp12item * 100) / ESumItem),2) + '%';
                this.tblFooterTab4[16].value = ewp13item.toLocaleString() + '\n' + this.global.Round(((ewp13item * 100) / ESumItem),2) + '%';
                this.tblFooterTab4[17].value = ewp14item.toLocaleString() + '\n' + this.global.Round(((ewp14item * 100) / ESumItem),2) + '%';
                this.tblFooterTab4[18].value = ewp15item.toLocaleString() + '\n' + this.global.Round(((ewp15item * 100) / ESumItem),2) + '%';
                this.tblFooterTab4[19].value = ewp16item.toLocaleString() + '\n' + this.global.Round(((ewp16item * 100) / ESumItem),2) + '%';
                this.tblFooterTab4[20].value = ewpOTitem.toLocaleString() + '\n' + this.global.Round(((ewpOTitem * 100) / ESumItem),2) + '%';
                this.tblFooterTab4[21].value = ESumItem.toLocaleString() + '\n' + this.global.Round(((ESumItem * 100) / AllSumItem),2) + '%';

                this.tblFooterTab4[23].value = dwp08qty.toLocaleString() + '\n' + this.global.Round(((dwp08qty * 100) / dSumqty),2) + '%';
                this.tblFooterTab4[24].value = dwp09qty.toLocaleString() + '\n' + this.global.Round(((dwp09qty * 100) / dSumqty),2) + '%';
                this.tblFooterTab4[25].value = dwp10qty.toLocaleString() + '\n' + this.global.Round(((dwp10qty * 100) / dSumqty),2) + '%';
                this.tblFooterTab4[26].value = dwp11qty.toLocaleString() + '\n' + this.global.Round(((dwp11qty * 100) / dSumqty),2) + '%';
                this.tblFooterTab4[27].value = dwp12qty.toLocaleString() + '\n' + this.global.Round(((dwp12qty * 100) / dSumqty),2) + '%';
                this.tblFooterTab4[28].value = dwp13qty.toLocaleString() + '\n' + this.global.Round(((dwp13qty * 100) / dSumqty),2) + '%';
                this.tblFooterTab4[29].value = dwp14qty.toLocaleString() + '\n' + this.global.Round(((dwp14qty * 100) / dSumqty),2) + '%';
                this.tblFooterTab4[30].value = dwp15qty.toLocaleString() + '\n' + this.global.Round(((dwp15qty * 100) / dSumqty),2) + '%';
                this.tblFooterTab4[31].value = dwp16qty.toLocaleString() + '\n' + this.global.Round(((dwp16qty * 100) / dSumqty),2) + '%';
                this.tblFooterTab4[32].value = dwpOTqty.toLocaleString() + '\n' + this.global.Round(((dwpOTqty * 100) / dSumqty),2) + '%';
                this.tblFooterTab4[33].value = dSumqty.toLocaleString() + '\n' + this.global.Round(((dSumqty * 100) / AllSumqty),2) + '%';

                this.tblFooterTab4[34].value = ewp08qty.toLocaleString() + '\n' + this.global.Round(((ewp08qty * 100) / ESumqty),2) + '%';
                this.tblFooterTab4[35].value = ewp09qty.toLocaleString() + '\n' + this.global.Round(((ewp09qty * 100) / ESumqty),2) + '%';
                this.tblFooterTab4[36].value = ewp10qty.toLocaleString() + '\n' + this.global.Round(((ewp10qty * 100) / ESumqty),2) + '%';
                this.tblFooterTab4[37].value = ewp11qty.toLocaleString() + '\n' + this.global.Round(((ewp11qty * 100) / ESumqty),2) + '%';
                this.tblFooterTab4[38].value = ewp12qty.toLocaleString() + '\n' + this.global.Round(((ewp12qty * 100) / ESumqty),2) + '%';
                this.tblFooterTab4[39].value = ewp13qty.toLocaleString() + '\n' + this.global.Round(((ewp13qty * 100) / ESumqty),2) + '%';
                this.tblFooterTab4[40].value = ewp14qty.toLocaleString() + '\n' + this.global.Round(((ewp14qty * 100) / ESumqty),2) + '%';
                this.tblFooterTab4[41].value = ewp15qty.toLocaleString() + '\n' + this.global.Round(((ewp15qty * 100) / ESumqty),2) + '%';
                this.tblFooterTab4[42].value = ewp16qty.toLocaleString() + '\n' + this.global.Round(((ewp16qty * 100) / ESumqty),2) + '%';
                this.tblFooterTab4[43].value = ewpOTqty.toLocaleString() + '\n' + this.global.Round(((ewpOTqty * 100) / ESumqty),2) + '%';
                this.tblFooterTab4[44].value = ESumqty.toLocaleString() + '\n' + this.global.Round(((ESumqty * 100) / AllSumqty),2) + '%';

                break;
            default :
                break;
            
        }
    }

    
    SumFooter(data : any,keyName : string){
        
        let sum = data.reduce((prev, next) => prev + next[keyName], 0);
        return sum;
    }

    TabChanged(event){
        this.CurrentTab = event.index;
    }
    
    FormateDate(date) {

        let d = new Date(date)
        let day = d.getDate();
        let newDay = day.toString().length < 2 ? 0 + '' + day.toString() : day.toString();
        let m = d.getMonth() + 1;
        let newMonth = m.toString().length < 2 ? 0 + '' + m.toString() : m.toString();
        let y = d.getFullYear();
        return newDay + '-' + newMonth + '-' + y;
    }

    FirstDateOfMonth(){
        var date = new Date();
        var firstDay = new Date(date.getFullYear(), date.getMonth(), 1);
        firstDay.setDate(firstDay.getDate() + 1);
        return firstDay;
    }

}

