import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';

import { WareHouseComponent } from 'src/app/pages/warehouse/warehouse.component';
// import { SNM001PComponent } from 'src/app/pages/warehouse/SNM001P/SNM001P.component';
// import { SNM001P_WComponent } from 'src/app/pages/warehouse/SNM001P_W/SNM001P_W.component';
// import { SNPP999EComponent } from 'src/app/pages/warehouse/SNPP999E/SNPP999E.component';
import { SNPP999ZComponent } from 'src/app/pages/warehouse/SNPP999Z/SNPP999Z.component';
import { SNPR029Component } from 'src/app/pages/warehouse/SNPR029/SNPR029.component';
import { SNPR037Component } from 'src/app/pages/warehouse/SNPR037/SNPR037.compoent';
import { SNSE054D_ZComponent } from 'src/app/pages/warehouse/SNSE054D_Z/SNSE054D_Z.component';
import { SNSE054D_ZBComponent } from 'src/app/pages/warehouse/SNSE054D_ZB/SNSE054D_ZB.component';
import { SNSE052Component } from 'src/app/pages/warehouse/SNSE052/SNSE052.component';
import { SNSE157Component } from 'src/app/pages/warehouse/SNSE157/SNSE157.component';
import { SNSE181Component } from 'src/app/pages/warehouse/SNSE181/SNSE181.component';
import { SNSE182Component } from '../../pages/warehouse/SNSE182/SNSE182.component';
// import { SNM111PComponent } from '../../pages/warehouse/SNM111P/SNM111P.component';
// import { SNSE196Component } from '../../pages/warehouse/SNSE196/SNSE196.component';
import { SNPP105Component } from '../../pages/warehouse/SNPP105/SNPP105.component';
import { SNM102PComponent } from '../../pages/warehouse/SNM102P/SNM102P.component';
import { SNM108PComponent } from '../../pages/warehouse/SNM108P/SNM108P.component';
import { SNM109PComponent } from '../../pages/warehouse/SNM109P/SNM109P.component';
import { SNM110PComponent } from '../../pages/warehouse/SNM110P/SNM110P.component';
import { SNPE015Component } from '../../pages/warehouse/SNPE015/SNPE015.component';
import { SNSE064_M2Component } from '../../pages/warehouse/SNSE064_M2/SNSE064_M2.component';
import { SNSQ090Component } from '../../pages/warehouse/SNSQ090/SNSQ090.component';
// import { SNSQ090_HDComponent } from '../../pages/warehouse/SNSQ090_HD/SNSQ090_HD.component';
import { SNSR040Component } from '../../pages/warehouse/SNSR040/SNSR040.component';
import { SNSR041Component } from '../../pages/warehouse/SNSR041/SNSR041.component';
import { WEEKLYREPComponent } from '../../pages/warehouse/WEEKLYREP/WEEKLYREP.component';
import { SNSE202Component } from '../../pages/warehouse/SNSE202/SNSE202.component';
// import { SNSJ006_MComponent } from '../../pages/warehouse/SNSJ006_M/SNSJ006_M.component';
// import { SNSJ007_MComponent } from '../../pages/warehouse/SNSJ007_M/SNSJ007_M.component';
import { SNM002PComponent } from '../../pages/warehouse/SNM002P/SNM002P.component';
import { SNSE195Component } from '../../pages/warehouse/SNSE195/SNSE195.component';
import { SNSE194Component } from '../../pages/warehouse/SNSE194/SNSE194.component';
import { SNSE193Component } from '../../pages/warehouse/SNSE193/SNSE193.component';
import { SNSE192Component } from '../../pages/warehouse/SNSE192/SNSE192.component';
// import { SNSE190Component } from '../../pages/warehouse/SNSE190/SNSE190.component';
import { SNSE187Component } from '../../pages/warehouse/SNSE187/SNSE187.component';
import { SNSE186Component } from '../../pages/warehouse/SNSE186/SNSE186.component';
// import { SNSE185Component } from '../../pages/warehouse/SNSE185/SNSE185.component';
import { SNSE184Component } from '../../pages/warehouse/SNSE184/SNSE184.component';
// import { SNSE183Component } from '../../pages/warehouse/SNSE183/SNSE183.component';
import { MaterialImportModule } from '../shared/material.module';
import { SNSQ088_001Component } from 'src/app/pages/warehouse/SNSQ088_001/SNSQ088_001.component';
import { SNPE013Component } from 'src/app/pages/warehouse/SNPE013/SNPE013.component';
import { SNPE023Component } from 'src/app/pages/warehouse/SNPE023/SNPE023.component';
import { SNPR029_MComponent } from 'src/app/pages/warehouse/SNPR029_M/SNPR029_M.component';
import { SNPE034Component } from 'src/app/pages/warehouse/snpe034/snpe034.component';
import { SNPE036Component } from 'src/app/pages/warehouse/snpe036/snpe036.component';
import { SNM025PComponent } from 'src/app/pages/warehouse/SNM025P/SNM025P.component';
import { SNM026PComponent } from 'src/app/pages/warehouse/SNM026P/SNM026P.component';
import { RoleResolver } from 'src/app/core/role-resolver.service';
import { SNM033Component } from 'src/app/pages/warehouse/SNM033/SNM033.component';
import { SNSD162Component } from 'src/app/pages/warehouse/SNSD162/SNSD162.component';
import { SNM007PComponent } from 'src/app/pages/warehouse/SNM007P/SNM007P.component';
import { SNM016PComponent } from 'src/app/pages/warehouse/SNM016P/SNM016P.component';


@NgModule({
  declarations: [

    WareHouseComponent,
    // SNM001PComponent,
    // SNM001P_WComponent,
    // SNPP999EComponent,
    SNPP999ZComponent,
    SNPR029Component,
    SNPR037Component,
    SNSE054D_ZComponent,
    SNSE054D_ZBComponent,
    SNSE052Component,
    SNSE157Component,
    SNSE181Component,
    SNSE182Component,
    // SNM111PComponent,
    // SNSE196Component,
    SNPP105Component,
    SNM102PComponent,
    SNM108PComponent,
    SNM109PComponent,
    SNM110PComponent,
    SNPE015Component,
    SNSE064_M2Component,
    SNSQ090Component,
    // SNSQ090_HDComponent,
    SNSR040Component,
    SNSR041Component,
    WEEKLYREPComponent,
    SNSE202Component,
    // SNSJ006_MComponent,
    // SNSJ007_MComponent,
    SNM002PComponent,
    SNSE195Component,
    SNSE194Component,
    SNSE193Component,
    SNSE192Component,
    // SNSE190Component,
     SNSE187Component,
    SNSE186Component,
    // SNSE185Component,
    SNSE184Component,
    // SNSE183Component,
    SNSQ088_001Component,
    SNPE013Component,
    SNPE023Component,
    SNPR029_MComponent,
    SNM025PComponent,
    SNM026PComponent,
    SNPE034Component,
    SNPE036Component,
    SNM033Component,
    SNSD162Component,
    SNM007PComponent,
    SNM016PComponent
  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,

    //Material imports
    MaterialImportModule,



    RouterModule.forChild([
      {
        path: '',
        component: WareHouseComponent,
        children: [
          // {
          //   path: 'SNM001P',
          //   component: SNM001PComponent,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNM001P_W',
          //   component: SNM001P_WComponent,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNPP999E',
          //   component: SNPP999EComponent,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
          {
            path : 'SNM016P',
            component : SNM016PComponent,
            resolve : {
              role : RoleResolver
            }
          },
          {
            path : 'SNM007P',
            component : SNM007PComponent,
            resolve : {
              role : RoleResolver
            }
          },
          {
            path: 'SNPP999Z',
            component: SNPP999ZComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPR029',
            component: SNPR029Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPR037',
            component: SNPR037Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE054D_Z',
            component: SNSE054D_ZComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE054D_ZB',
            component: SNSE054D_ZBComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE052',
            component: SNSE052Component,
            resolve: {
              role: RoleResolver
            },
          },
           {
             path: 'SNSE157',
             component: SNSE157Component,
             resolve: {
               role: RoleResolver
             },
           },
          {
            path: 'SNSE181',
            component: SNSE181Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE182',
            component: SNSE182Component,
            resolve: {
              role: RoleResolver
            },
          },
          // {
          //   path: 'SNM111P',
          //   component: SNM111PComponent,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNSE196',
          //   component: SNSE196Component,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
          {
            path: 'SNPP105',
            component: SNPP105Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM102P',
            component: SNM102PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM108P',
            component: SNM108PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM109P',
            component: SNM109PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM110P',
            component: SNM110PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPE015',
            component: SNPE015Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE064_M2',
            component: SNSE064_M2Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSQ090',
            component: SNSQ090Component,
            resolve: {
              role: RoleResolver
            },
          },
          // {
          //   path: 'SNSQ090_HD',
          //   component: SNSQ090_HDComponent,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
          {
            path: 'SNSR040',
            component: SNSR040Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSR041',
            component: SNSR041Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'WEEKLYREP',
            component: WEEKLYREPComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE202',
            component: SNSE202Component,
            resolve: {
              role: RoleResolver
            },
          },
          // {
          //   path: 'SNSJ006_M',
          //   component: SNSJ006_MComponent,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNSJ007_M',
          //   component: SNSJ007_MComponent,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
          {
            path: 'SNM002P',
            component: SNM002PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE195',
            component: SNSE195Component,
            resolve: {
              role: RoleResolver
            },
          },
           {
             path: 'SNSE194',
             component: SNSE194Component,
             resolve: {
               role: RoleResolver
             },
           },
           {
             path: 'SNSE193',
             component: SNSE193Component,
             resolve: {
               role: RoleResolver
             },
           },
           {
             path: 'SNSE192',
             component: SNSE192Component,
             resolve: {
               role: RoleResolver
             },
           },
          // {
          //   path: 'SNSE190',
          //   component: SNSE190Component,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
           {
             path: 'SNSE187',
             component: SNSE187Component,
             resolve: {
               role: RoleResolver
             },
           },
          {
            path: 'SNSE186',
            component: SNSE186Component,
            resolve: {
              role: RoleResolver
            },
          },
          // {
          //   path: 'SNSE185',
          //   component: SNSE185Component,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
          {
            path: 'SNSE184',
            component: SNSE184Component,
            resolve: {
              role: RoleResolver
            },
          },
          // {
          //   path: 'SNSE184',
          //   component: SNSE183Component,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
          {
            path: 'SNSQ088',
            component: SNSQ088_001Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPE013',
            component: SNPE013Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPE023',
            component: SNPE023Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPR029_M',
            component: SNPR029_MComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM025P',
            component: SNM025PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM026P',
            component: SNM026PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPE034',
            component: SNPE034Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPE036',
            component: SNPE036Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path:'SNM033',
            component:SNM033Component,
            resolve:{
              role:RoleResolver
            }
          },
          {
            path: 'SNSD162',
            component: SNSD162Component,
            resolve: {
              role: RoleResolver
            }
          }
        ],
        canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [],
  providers: [AuthGuard, RoleResolver],
})
export class WareHouseModule { }
