import { Component, OnInit } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';

@Component({
    selector: 'role',
    templateUrl: './portal.component.html',
    styleUrls: ['./portal.component.css']
})
export class PortalComponent implements OnInit {
    public roles: Array<any>;

    constructor(
        protected http: HttpService,
        protected router: Router
    ) { }

    ngOnInit(): void {
        //localStorage.clear();
    }


    roleSelected(roleId: number) {
        this.http.patch("System", "SetRoleID", roleId, null)
            .subscribe(result => {
                localStorage.setItem("jwtToken", result);
                this.router.navigate(['/main'])
            })
    }
}
