import { Component, OnInit} from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { FormGroup, FormControl, FormBuilder } from '@angular/forms'
import { Router } from '@angular/router';
import { Observable, config } from 'rxjs';


@Component({
  selector: 'snse012',
  templateUrl: './SNSE012.component.html',
  styleUrls: ['./SNSE012.component.css']
})



export class SNSE012Component implements OnInit {

  constructor(
    private http: HttpService,
    private router: Router
  ) { }

  public CustomerList: any;
  private loaded: boolean = false;

  public tableData: any;
  
  public tableName: string;


  ngOnInit() {

    this.tableName = "ReportConfigure";
    this.CustomerList = [{ ID: 1, CUSTOMER_CODE: "AAA" }, { ID: 2, CUSTOMER_CODE: "BBB" }, { ID: 3, CUSTOMER_CODE: "CCC" }]

    this.tableData = [
      {
        "item_No": "A",
        "Sub": "A",
        "Order_Part_No": "A",
        "Accept_Part_NO": "A",
        "Allocate_Date": "A",
        "Order_Qrt": "A",
        "Allocate_Qrt": "A",
        "Unit_Price": "A",
        "Allocate_Amt": "A"

      }, {
        "item_No": "B",
        "Sub": "B",
        "Order_Part_No": "B",
        "Accept_Part_NO": "B",
        "Allocate_Date": "B",
        "Order_Qrt": "B",
        "Allocate_Qrt": "B",
        "Unit_Price": "B",
        "Allocate_Amt": "B"
      },
      {
        "item_No": "C",
        "Sub": "C",
        "Order_Part_No": "C",
        "Accept_Part_NO": "C",
        "Allocate_Date": "C",
        "Order_Qrt": "C",
        "Allocate_Qrt": "C",
        "Unit_Price": "C",
        "Allocate_Amt": "C"
      },
      {
        "item_No": "A",
        "Sub": "A",
        "Order_Part_No": "A",
        "Accept_Part_NO": "A",
        "Allocate_Date": "A",
        "Order_Qrt": "A",
        "Allocate_Qrt": "A",
        "Unit_Price": "A",
        "Allocate_Amt": "A"
      },
      {
        "item_No": "A",
        "Sub": "A",
        "Order_Part_No": "A",
        "Accept_Part_NO": "A",
        "Allocate_Date": "A",
        "Order_Qrt": "A",
        "Allocate_Qrt": "A",
        "Unit_Price": "A",
        "Allocate_Amt": "A"
      },
      {
        "item_No": "A",
        "Sub": "A",
        "Order_Part_No": "A",
        "Accept_Part_NO": "A",
        "Allocate_Date": "A",
        "Order_Qrt": "A",
        "Allocate_Qrt": "A",
        "Unit_Price": "A",
        "Allocate_Amt": "A"
      },
      {
        "item_No": "A",
        "Sub": "A",
        "Order_Part_No": "A",
        "Accept_Part_NO": "A",
        "Allocate_Date": "A",
        "Order_Qrt": "A",
        "Allocate_Qrt": "A",
        "Unit_Price": "A",
        "Allocate_Amt": "A"
      },
      {
        "item_No": "A",
        "Sub": "A",
        "Order_Part_No": "A",
        "Accept_Part_NO": "A",
        "Allocate_Date": "A",
        "Order_Qrt": "A",
        "Allocate_Qrt": "A",
        "Unit_Price": "A",
        "Allocate_Amt": "A"
      },
      {
        "item_No": "A",
        "Sub": "A",
        "Order_Part_No": "A",
        "Accept_Part_NO": "A",
        "Allocate_Date": "A",
        "Order_Qrt": "A",
        "Allocate_Qrt": "A",
        "Unit_Price": "A",
        "Allocate_Amt": "A"
      },
      {
        "item_No": "A",
        "Sub": "A",
        "Order_Part_No": "A",
        "Accept_Part_NO": "A",
        "Allocate_Date": "A",
        "Order_Qrt": "A",
        "Allocate_Qrt": "A",
        "Unit_Price": "A",
        "Allocate_Amt": "A"
      },
      {
        "item_No": "A",
        "Sub": "A",
        "Order_Part_No": "A",
        "Accept_Part_NO": "A",
        "Allocate_Date": "A",
        "Order_Qrt": "A",
        "Allocate_Qrt": "A",
        "Unit_Price": "A",
        "Allocate_Amt": "A"
      },
      {
        "item_No": "A",
        "Sub": "A",
        "Order_Part_No": "A",
        "Accept_Part_NO": "A",
        "Allocate_Date": "A",
        "Order_Qrt": "A",
        "Allocate_Qrt": "A",
        "Unit_Price": "A",
        "Allocate_Amt": "A"
      }
    ]
    this.loaded = true;
  }






}
