import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';

@Component({
  selector: 'snsq033_001',
  templateUrl: './snsq033_001.component.html',
  styleUrls: ['./snsq033_001.component.css']
})



export class SNSQ033_001Component implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router
  ) { }

  public SelectList: any = [];
  public data: any;
  public masterSelected: boolean;
  public checklist: any;
  public checkedList: any;

  ngOnInit() {

    this.masterSelected = false;
    
    this.data = [{
      id: '1',
      SEQ : '1',
      PART_NO: '1',
      PART_NAME: '1',
      CREATE_DATE: '1',
      GLOBAL_SUPPLIER_CODE: '1',
      LOCAL_SUPPLIER_CODE: '1',
      BASE_PRICE: '1',
      UPDATE_DATE: '1',
      isSelected: false
    },
      {
      id: '2',
      SEQ: '2',
      PART_NO: '2',
      PART_NAME: '2',
      CREATE_DATE: '2',
      GLOBAL_SUPPLIER_CODE: '2',
      LOCAL_SUPPLIER_CODE: '2',
      BASE_PRICE: '2',
      UPDATE_DATE: '2',
      isSelected: false
    },
      {
      id: '3',
      SEQ: '3',
      PART_NO: '3',
      PART_NAME: '3',
      CREATE_DATE: '3',
      GLOBAL_SUPPLIER_CODE: '3',
      LOCAL_SUPPLIER_CODE: '3',
      BASE_PRICE: '3',
      UPDATE_DATE: '3',
      isSelected: false
    },
      {
      id: '4',
      SEQ: '4',
      PART_NO: '4',
      PART_NAME: '4',
      CREATE_DATE: '4',
      GLOBAL_SUPPLIER_CODE: '4',
      LOCAL_SUPPLIER_CODE: '4',
      BASE_PRICE: '4',
      UPDATE_DATE: '4',
      isSelected: false
    },

    ]
    this.getCheckedItemList();
  }

  
  checkUncheckAll() {
    for (var i = 0; i < this.data.length; i++) {
      this.data[i].isSelected = this.masterSelected;
    }
    this.getCheckedItemList();
  }

 
  isAllSelected() {
    this.masterSelected = this.data.every(function (item: any) {
      return item.isSelected == true;
    })
    this.getCheckedItemList();
  }

  
  getCheckedItemList() {
    this.checkedList = [];
    for (var i = 0; i < this.data.length; i++) {
      if (this.data[i].isSelected)
        this.checkedList.push(this.data[i]);
    }
    this.checkedList = JSON.stringify(this.checkedList);
  }


}
